pub struct LeF32Decoder<I: Iterator<Item = u8>> {
    iter: I,
}

impl<I: Iterator<Item = u8>> LeF32Decoder<I> {
    pub fn new(iter: I) -> Self {
        Self { iter }
    }
}

impl<I: Iterator<Item = u8>> Iterator for LeF32Decoder<I> {
    type Item = f32;

    fn next(&mut self) -> Option<f32> {
        let mut bytes = [0; 4];
        for b in &mut bytes {
            *b = self.iter.next()?;
        }

        Some(f32::from_le_bytes(bytes))
    }
}
